/*
--------------------------------
Kickvoter   
version:        1.02
By:             Nicoon
Email:          nicoon@gmail.com
---------------------------------
*/
/*
--------------------- - -
> On Text events
--------------------- - -
*/

ON *:TEXT:*:#: {
  if ($me !isop $chan) return
  if ((!$istok($kickvote(channels),$chan,44)) && (!$kickvote(on)) && (!$kickvote(allchans))) { return }
  if ($1 == $kickvote(start)) {
    if (!$2) { .notice $nick Please specify a user. | return }
    if ($2 == $me) { .notice $nick You cannot kick the host. | return }
    if ($2 !ison $chan) { .notice $nick $2 is not on $chan $+ . | return }
    if (p isin $level($address($2,2))) { .notice $nick $2 is protected. | return }
    if ($readini($scriptdirkickvote.ini,$chan,kick)) { .notice $nick Vote already in progress. | return }
    writeini -n $+(",$scriptdirkickvote.ini,") $chan kick $2
    writeini -n $+(",$scriptdirkickvote.ini,") $chan start $address($nick,2)
    write -cn $+(",$scriptdirvotes/,$chan,.txt,") $address($nick,2) $+ $crlf
    var %output = $kickvote(output_start)
    var %output = $replace(%output,&nick,$2)
    var %output = $replace(%output,&c,$chr(3),&b,$chr(2),&u,$chr(31))
    var %output = $replace(%output,&votestart,$kickvote(start),&votefor,$kickvote(vote),&votecancel,$kickvote(cancel))
    msg $chan %output
    if ($floor($calc(($nick($chan,0) / 100) * $kickvote(percent) )) == 0) { 
      var %kicked = $calc($readini($scriptdirkicks.ini,$chan,$address($2,2)) + 1)
      writeini -n $+(",$scriptdirkicks.ini,") $chan $address($2,2) %kicked
      if ((%kicked >= $kickvote(kicks)) && ($kickvote(ban))) { mode $chan +b $address($2,2) }
      kick $chan $2 You have been voted to leave. 
      return
    }
    msg $chan $floor($calc(($nick($chan,0) / 100) * $kickvote(percent) )) more needed to pass.
    .timervkick $+ $chan 1 $kickvote(timer) vkickend $chan
  }
  if ($1 == $kickvote(vote)) {
    if (!$readini($scriptdirkickvote.ini,$chan,kick)) { .notice $nick There's no kick vote in progress. | return }
    var %vote = $read($scriptdirvotes/ $+ $chan $+ .txt,w,$address($nick,2))
    if (%vote) { .notice $nick You have already voted. | return }
    write -n $+(",$scriptdirvotes/,$chan,.txt,") $address($nick,2) $+ $crlf
    var %votes = $calc(($floor($calc(($nick($chan,0) / 100) * $kickvote(percent) )) - $lines($scriptdirvotes/ $+ $chan $+ .txt)) + 1)
    if (%votes > 0) { 
      var %output = $kickvote(output_voteleft)
      var %output = $replace(%output,&c,$chr(3),&b,$chr(2),&u,$chr(31))
      var %output = $replace(%output,&votestart,$kickvote(start),&votefor,$kickvote(vote),&votecancel,$kickvote(cancel),&votes,%votes)
      msg $chan %output
    }
    else { 
      var %kicked = $calc($readini($scriptdirkicks.ini,$chan,$address($readini($scriptdirkickvote.ini,$chan,kick),2)) + 1)
      writeini -n $+(",$scriptdirkicks.ini,") $chan $address($readini($scriptdirkickvote.ini,$chan,kick),2) %kicked
      if ((%kicked >= $kickvote(kicks)) && ($kickvote(ban))) { mode $chan +b $address($readini($scriptdirkickvote.ini,$chan,kick),2) }
      kick $chan $readini($scriptdirkickvote.ini,$chan,kick) You have been voted to leave.
      .timervkick $+ $chan off
      vkickend $chan
    }
  }
  if ($1 == $kickvote(cancel)) {
    if (!$readini($scriptdirkickvote.ini,$chan,kick)) { .notice $nick No vote in progress. | return }
    if (($readini($scriptdirkickvote.ini,$chan,start) != $address($nick,2)) && (a !isin $level($address($nick,2)))) { .notice $nick You didn't start the vote. | return }
    .timervkick $+ $chan off
    vkickcancel $chan
  }
}
alias kickvote {
  if (!$1) return
  var %return $readini($scriptdirkickvote.ini,kickvote,$1)
  return %return
}
alias vkickend {
  if (!$1) return
  if ($floor($calc((100 / $nick($1,0)) * $lines($scriptdirvotes/ $+ $1 $+ .txt))) < $kickvote(percent)) { 
    var %output = $kickvote(output_votefail)
    var %output = $replace(%output,&c,$chr(3),&b,$chr(2),&u,$chr(31))
    var %output = $replace(%output,&votestart,$kickvote(start),&votefor,$kickvote(vote),&votecancel,$kickvote(cancel))
    msg $1 %output
  }
  .remini $+(",$scriptdirkickvote.ini,") $1
  write -c $+(",$scriptdirvotes/,$chan,.txt,")
}
alias vkickcancel {
  if (!$1) return
  .remini $+(",$scriptdirkickvote.ini,") $1
  write -c $+(",$scriptdirvotes/,$chan,.txt,")
  var %output = $kickvote(output_votecancel)
  var %output = $replace(%output,&c,$chr(3),&b,$chr(2),&u,$chr(31))
  var %output = $replace(%output,&votestart,$kickvote(start),&votefor,$kickvote(vote),&votecancel,$kickvote(cancel))
  msg $1 %output
  .timervkick $+ $1 off
}
ON *:NICK:{
  var %chans = $numtok($kickvote(channels),44), %i = 1
  while (%i <= %chans) {
    if ($readini($scriptdirkickvote.ini,$gettok($kickvote(channels),%i,44),kick) == $nick) { writeini -n $+(",$scriptdirkickvote.ini,") $gettok($kickvote(channels),%i,44) kick $newnick }
    inc %i
  }
}
/*
--------------------- - -
> Dialogs
--------------------- - -
*/
dialog votekick {
  size -1 -1 300 320
  title "-(KickVoteR)-"
  box "Channels:",1,5 5 290 125
  list 2, 10 20 200 95, vsbar
  button "Add",3, 215 20 70 20 
  button "Remove",4, 215 40 70 20 
  button "Clear All",5, 215 70 70 20 
  check "Enable for all channels",6, 10 105 200 20 
  check "Ban user after",7,15 210 100 20
  edit "",8,150 210 50 20, disable
  text "kicks",9,205 213 50 20
  text "Votes to kick:",10,15 235 100 20 
  edit "",11,150 230 50 20
  text "%",12,205 235 50 20
  box "",13,5 192 290 90
  button "&Done",14, 190 290 100 20, ok
  box "",15,5 122 290 78
  text "Start trigger:",16,15 135 100 20
  edit "",17,150 133 130 20
  text "Vote trigger:"18, 15 155 100 20
  edit "",19,150 153 130 20
  text "Cancel trigger:",20,15 175 100 20
  edit "",21,150 173 130 20 
  text "Cancel vote after",22,15 255 100 20
  edit "",23,150 253 50 20
  text "secs",24,205 255 20 20
  button "Refine Output",25,5 290 100 20
  check "OFF",26,215 105 70 20, push
}
ON *:DIALOG:votekick:*:*:{
  if ($devent == init) {
    var %i = 1, %n = $numtok($kickvote(channels),44)
    while (%i <= %n) {
      did -a $dname 2 $gettok($kickvote(channels),%i,44)
      inc %i
    }
    if ($kickvote(allchans)) { did -c $dname 6 | did -b $dname 2,3,4,5 }
    if ($kickvote(ban)) { did -c $dname 7 | did -e $dname 8 }
    if ($kickvote(kicks)) { did -a $dname 8 $kickvote(kicks) }
    else {
      writeini -n $+(",$scriptdirkickvote.ini,") kickvote kicks 3
      did -a $dname 8 3 
    }
    if ($kickvote(percent)) { did -a $dname 11 $kickvote(percent) }
    else { 
      writeini -n $+(",$scriptdirkickvote.ini,") kickvote percent 66
      did -a $dname 11 66 
    }
    if ($kickvote(start)) did -a $dname 17 $kickvote(start)
    else { 
      writeini -n $+(",$scriptdirkickvote.ini,") kickvote start :vkick
      did -a $dname 17 :vkick
    }
    if ($kickvote(vote)) did -a $dname 19 $kickvote(vote)
    else { 
      writeini -n $+(",$scriptdirkickvote.ini,") kickvote vote :kvote
      did -a $dname 19 :kvote
    }
    if ($kickvote(cancel)) did -a $dname 21 $kickvote(cancel)
    else { 
      writeini -n $+(",$scriptdirkickvote.ini,") kickvote cancel :vcancel
      did -a $dname 21 :vcancel
    }
    if ($kickvote(timer)) { did -a $dname 23 $kickvote(timer) }
    else { 
      writeini -n $+(",$scriptdirkickvote.ini,") kickvote timer 120
      did -a $dname 23 120
    }
    if ($kickvote(on)) { did -ra $dname 26 ON | did -c $dname 26 }
  }
  if ($devent == edit) {
    if ($did == 8) {
      if ($did($dname,8) isnum) { writeini -n $+(",$scriptdirkickvote.ini,") kickvote kicks $did($dname,8) }
      else { did -ra $dname 8 $left($did($dname,8),$calc($len($did($dname,8)) - 1)) | var %a = $input(Please enter numeric values only.,o,KickVote) }
    }
    if ($did == 11) {
      if ($did($dname,11) isnum 0-100) { writeini -n $+(",$scriptdirkickvote.ini,") kickvote percent $did($dname,11) }
      else { did -ra $dname 11 $left($did($dname,11),$calc($len($did($dname,11)) - 1)) | var %a = $input(Please enter a numeric value that's 100 or below.,o,KickVote) }
    }
    if ($did == 17) { writeini -n $+(",$scriptdirkickvote.ini,") kickvote start $did($dname,17) }
    if ($did == 19) { writeini -n $+(",$scriptdirkickvote.ini,") kickvote vote $did($dname,19) }
    if ($did == 21) { writeini -n $+(",$scriptdirkickvote.ini,") kickvote cancel $did($dname,21) }
    if ($did == 23) {
      if ($did($dname,23) isnum) { writeini -n $+(",$scriptdirkickvote.ini,") kickvote timer $did($dname,23) }
      else { did -ra $dname 23 $left($did($dname,23),$calc($len($did($dname,23)) - 1)) | var %a = $input(Please enter numeric values only.,o,KickVote) }
    }
  }
  if ($devent == sclick) {
    if ($did == 3) { 
      var %u = $?="What channel?"
      if (%u) { writeini -n $+(",$scriptdirkickvote.ini,") kickvote channels $addtok($kickvote(channels),%u,44) | did -a $dname 2 %u }
    }
    if ($did == 4) { 
      if ($did($dname,2).sel) {
        if ($numtok($kickvote(channels),44) > 1) { writeini -n $+(",$scriptdirkickvote.ini,") kickvote channels $deltok($kickvote(channels),$did($dname,2).sel,44) }
        else { remini $+(",$scriptdirkickvote.ini,") kickvote channels }
        did -d $dname 2 $did($dname,2).sel
      }
    }
    if ($did == 5) { 
      remini $+(",$scriptdirkickvote.ini,") kickvote channels 
      did -r $dname 2 
    }
    if ($did == 6) { 
      if ($did($dname,6).state == 1) { did -b $dname 2,3,4,5 | writeini -n $+(",$scriptdirkickvote.ini,") kickvote allchans $true }
      else { did -e $dname 2,3,4,5 | writeini -n $+(",$scriptdirkickvote.ini,") kickvote allchans $false }
    }
    if ($did == 7) { 
      if ($did($dname,7).state == 1) { did -e $dname 8 | writeini -n $+(",$scriptdirkickvote.ini,") kickvote ban $true }
      else { did -b $dname 8 | writeini -n $+(",$scriptdirkickvote.ini,") kickvote ban $false }
    }
    if ($did == 25) { if (!$dialog(votekick_output)) dialog -m votekick_output votekick_output }
    if ($did == 26) { 
      writeini -n $+(",$scriptdirkickvote.ini,") kickvote on $gettok($ $+ false.$true,$calc($did($dname,26).state + 1),46) 
      did -ra $dname 26 $gettok(OFF.ON,$calc($did($dname,26).state + 1),46) 
    }
  }
}

dialog votekick_output {
  size -1 -1 330 130
  title "-(KickVoteR)- Output"
  text "Start:",1,5 7 100 20
  edit "",2,100 5 200 20, autohs
  text "Votes Left:",3,5 27 100 20
  edit "",4,100 25 200 20, autohs
  text "Vote Failed:",5,5 47 100 20
  edit "",6,100 45 200 20, autohs
  text "Vote Canceled:",7,5 67 100 20
  edit "",8,100 65 200 20, autohs
  box "",10,0 -5 330 95
  button "Save!",9",225 100 100 20
}
ON *:DIALOG:votekick_output:*:*:{
  if ($devent == init) {
    did -a $dname 2 $replace($replace($replace($kickvote(output_start),&c,$chr(3)),&b,$chr(2)),&u,$chr(31))
    did -a $dname 4 $replace($replace($replace($kickvote(output_voteleft),&c,$chr(3)),&b,$chr(2)),&u,$chr(31))
    did -a $dname 6 $replace($replace($replace($kickvote(output_votefail),&c,$chr(3)),&b,$chr(2)),&u,$chr(31))
    did -a $dname 8 $replace($replace($replace($kickvote(output_votecancel),&c,$chr(3)),&b,$chr(2)),&u,$chr(31))
  }
  if ($devent == sclick) {
    if ($did == 9)  {
      if (($did($dname,2)) && ($did($dname,4)) && ($did($dname,6)) && ($did($dname,8))) {
        .writeini -n $+(",$scriptdirkickvote.ini,") kickvote output_start $replace($replace($replace($did($dname,2),$chr(3),&c),$chr(2),&b),$chr(31),&u)
        .writeini -n $+(",$scriptdirkickvote.ini,") kickvote output_voteleft $replace($replace($replace($did($dname,4),$chr(3),&c),$chr(2),&b),$chr(31),&u)
        .writeini -n $+(",$scriptdirkickvote.ini,") kickvote output_votefail $replace($replace($replace($did($dname,6),$chr(3),&c),$chr(2),&b),$chr(31),&u)
        .writeini -n $+(",$scriptdirkickvote.ini,") kickvote output_votecancel $replace($replace($replace($did($dname,8),$chr(3),&c),$chr(2),&b),$chr(31),&u)
        dialog -c $dname $dname
      } 
      else { 
        var %d = $input(Please fill out all the fields.,o,-(KickVoteR)-)
      }
    }
  }
}
/*
--------------------- - -
> Menus
--------------------- - -
*/

menu menubar {
  -(KickVoteR)-
  .Configure:{ if (!$dialog(votekick)) dialog -m votekick votekick }
  .-
  .Clear all records:{ write -c $+(",$scriptdirkicks.ini,") }
}
